<template>
  <section class="volumeSlider" @mouseup="onMouseUp" @mousedown="onMouseDown" @mouseleave="onMouseLeave" @mousemove="onMouseMove">
    <section class="volumeSlider__line">
      <section class="volumeSlider__background"></section>
      <section class="volumeSlider__current" v-bind:style="{ 'height': volume + '%' }"></section>
      <section class="volumeSlider__knob" v-bind:style="{ 'bottom': volume + '%' }"></section>
    </section>
  </section>
</template>

<script>
import Vue from 'vue';
import Component from 'vue-class-component';

@Component({
  props: {
    volume: Number,
  },
})
export default class PlayerVolumeSlider extends Vue {
  mouseDown = false;

  onMouseUp(event) {
    if (this.mouseDown) {
      this.$emit('volumeChanged', this.getVolumePercent(event));
    }
    this.mouseDown = false;
  }

  onMouseDown(event) {
    this.mouseDown = true;
    this.$emit('volumeChanged', this.getVolumePercent(event));
  }

  onMouseMove(event) {
    if (!this.mouseDown) {
      return;
    }
    this.$emit('volumeChanged', this.getVolumePercent(event));
  }

  onMouseLeave() {
    this.mouseDown = false;
  }

  getVolumePercent(event) {
    const { top, bottom } = this.$el.getBoundingClientRect();
    const { clientY } = event;
    if (clientY <= top) {
      return 100;
    }
    if (clientY >= bottom) {
      return 0;
    }
    const lineHeight = this.$el.clientHeight;
    const vol = 100 - (clientY - top) / lineHeight * 100;
    if (vol <= 5.5) {
      return 0;
    }
    return vol;
  }
}
</script>

<style lang="stylus" scoped>
.volumeSlider
  position absolute
  top -144px
  left 0
  right 0
  width 100%
  height 146px
  display block
  background-color #1c212c
  border-radius 3px

  &__line
    position absolute
    height 128px
    left 50%
    bottom 8px
    margin-left -1px

  &__background
    width 2px
    height 100%
    background-color #979797

  &__current
    position absolute
    width 100%
    height 30px
    bottom 0
    background-color yellow
    
  &__knob
    position absolute
    bottom 30%
    width 10px
    height 10px
    margin-left -4px
    margin-bottom -8px
    background-color yellow
    border-radius 50%
    overflow hidden
</style>

